package com.webhomecover.beans;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMapping;
import javax.servlet.http.HttpServletRequest;
import java.text.NumberFormat;
import java.sql.Date;
import org.apache.struts.validator.ValidatorForm;

/**
 * WebHomeCover Insurance System.
 *
 *  PolicyBean (Struts ValidatorForm)
 */

public class PolicyBean extends ValidatorForm implements java.io.Serializable
{
 private String policyNumber;
 private Date startDate;
 private Double annualPremium;
 private boolean paidUp;

 public PolicyBean()
 {
  super();
 }

 public void setPolicyNumber(String policynumber)
 {
  policyNumber = policynumber;
 }
 
 public void setStartDate(Date startDate)
 {
  this.startDate = startDate;
 }
 
 public void setAnnualPremium(Double premium)
 {
  annualPremium = premium;
 }

 public void setPaidUp(boolean paidUp)
 {
  this.paidUp = paidUp;
 }

 public String getPolicyNumber()
 {
  return policyNumber;
 }
 
 public Date getStartDate()
 {
  return startDate;
 }
 
 public Double getAnnualPremium()
 {
  return annualPremium;
 }

 public boolean getPaidUp()
 {
  return paidUp;
 }

 public ActionErrors validate(ActionMapping mapping, HttpServletRequest request)
 {
  ActionErrors errors = new ActionErrors();
  if(policyNumber == null || policyNumber.equals(""))
  {
	errors.add("policyNumber", new ActionMessage("error.policyNumber"));
  }
  if(annualPremium.doubleValue() == 0.0)
  {
 	errors.add("annualPremium", new ActionMessage("error.annualPremium"));
  }
  if(startDate==null)
  {
	errors.add("startDate", new ActionMessage("error.startDate"));
  }
  return errors;
 }
}